﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace CodeFirst.Data
{
  [Table("Customer")]
  public class Customer
  {
    [Key]
    [Index]
    [Column("CustomerId")]
    public Int32 CustomerId { get; set; }

    [Required]
    [MaxLength(128)]
    [MinLength(0)]
    [Column("CompanyName")]
    public String CompanyName { get; set; }

    [StringLength(100)]
    [Column("ContactName")]
    public String ContactName { get; set; }

    [StringLength(20)]
    public String ContactTitle { get; set; }

    [StringLength(256)]
    public String Address { get; set; }

    [StringLength(64)]
    public String City { get; set; }

    [StringLength(64)]
    public String Region { get; set; }

    [StringLength(10)]
    public String PostalCode { get; set; }

    [StringLength(64)]
    public String Country { get; set; }

    [StringLength(32)]
    public String Phone { get; set; }

    [StringLength(32)]
    public String Fax { get; set; }

    public ICollection<Order> Orders { get; set; }

    //[Timestamp]
    //public byte[] Version { get; set; }
  }
}
