﻿using System;
using System.Data.Entity;
using CodeFirst.Migrations;
using CodeFirst.Support;

namespace CodeFirst.Data
{
  //[DbConfigurationType(typeof(CustomerConfiguration))]
  internal class CustomerContext : DbContext
  {
    public CustomerContext() :
      base("CustomerConnectionString")
    {
      // logging into console
      //Database.Log = Console.Write;
    }

    public DbSet<Order> Orders { get; set; }
    public DbSet<Customer> Customers { get; set; }
    public DbSet<Shipping> Shippings { get; set; }
    //public DbSet<OrderItem> OrderItems { get; set; }

    protected override void OnModelCreating(DbModelBuilder modelBuilder)
    {
      //modelBuilder.Configurations.Add(new CustomerEntityConfiguration());
      //modelBuilder.Configurations.Add(new OrderEntityConfiguration());

      // db table name change via mapping
      //modelBuilder.Entity<Customer>().ToTable("Customers");
      //modelBuilder.Entity<Order>().ToTable("Orders", "dbo");
      
      // property persistence ignoration
      //modelBuilder.Entity<Customer>().Ignore(i => i.Fax);

      // column mapping
      //modelBuilder.Entity<Order>()
      //            .Property(p => p.RequiredDate)
      //            .HasColumnName("RD")
      //            .HasColumnOrder(11)
      //            .HasColumnType("datetime2");

      // set column as null
      //modelBuilder.Entity<Order>()
      //        .Property(p => p.Freight)
      //        .IsOptional();

      // set column as not null
      //modelBuilder.Entity<Order>()
      //       .Property(p => p.OrderDate)
      //       .IsRequired();

      //modelBuilder.Entity<Order>()
      //  .Property(p => p.ShipAddress)
      //  .HasMaxLength(50).IsFixedLength();

      // one-to-many relation
      //modelBuilder.Entity<Customer>()
      //            .HasMany<Order>(s => s.Orders)
      //            .WithRequired(s => s.Customer)
      //            .HasForeignKey(s => s.CustomerId);

      //modelBuilder.Entity<Customer>()
      //      .HasMany<Order>(s => s.Orders)
      //      .WithMany(c => c.Customer)
      //      .Map(cs =>
      //      {
      //        cs.MapLeftKey("CustomerId");
      //        cs.MapRightKey("OrderId");
      //        cs.ToTable("CustomerOrders");
      //      });

      base.OnModelCreating(modelBuilder);
    }
  }
}
  