﻿using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace CodeFirst.Data
{
  [Table("Order")]
  public class Order
  {
    [Key]
    [Index]
    public int OrderId { get; set; }

    [Required]
    public Int32 CustomerId { get; set; }

    [NotMapped]
    [ForeignKey("CustomerId")]
    public Customer Customer { get; set; }

    public Nullable<DateTime> OrderDate { get; set; }
    public Nullable<DateTime> RequiredDate { get; set; }
    public Nullable<DateTime> ShippedDate { get; set; }
    public Nullable<int> ShipVia { get; set; }

    [DefaultValue(1.0)]
    public Nullable<decimal> Freight { get; set; }

    [StringLength(64)]
    public string ShipName { get; set; }

    [StringLength(64)]
    public string ShipAddress { get; set; }

    [StringLength(64)]
    public string ShipCity { get; set; }

    [StringLength(64)]
    public string ShipRegion { get; set; }

    [StringLength(10)]
    public string ShipPostalCode { get; set; }

    [StringLength(32)]
    public string ShipCountry { get; set; }
  }
}
