﻿using System;
using System.Data.Entity;
using System.Linq;
using CodeFirst.Data;

namespace CodeFirst
{
  class Program
  {
    static void Main(string[] args)
    {
      using (var dc = new CustomerContext())
      {
        try
        {
          InitializeDatabase(dc);

          RetrieveCustomers(dc);
          //AddCustomer(dc);
          //DemonstrateTransaction(dc);
        }
        catch (Exception e)
        {

          throw;
        }
      }
    }

    private static void InitializeDatabase(CustomerContext dc)
    {
      dc.Database.Initialize(true);
    }

    private static void RetrieveCustomers(CustomerContext dc)
    {
      var customers = dc.Customers.ToList();
    }

    private static void AddCustomer(CustomerContext dc)
    {
      dc.Customers.Add(new Customer()
      {
        CustomerId = 1,
        CompanyName = "First Company"
      });
      dc.SaveChanges();
    }

    private static void DemonstrateTransaction(CustomerContext dc)
    {
      using (DbContextTransaction transaction = dc.Database.BeginTransaction())
      {
        try
        {
          Customer customer = new Customer() { CustomerId = 100, CompanyName = "Custom Customer" };
          dc.Customers.Add(customer);
          dc.Database.ExecuteSqlCommand(
              @"UPDATE [Customer] SET [CompanyName] = 'Edited Custom Customer'");
          dc.Customers.Remove(customer);

          dc.SaveChanges();
          transaction.Commit();
        }
        catch (Exception ex)
        {
          transaction.Rollback();
        }
      }
    }
  }
}
