﻿using System;
using CodeFirst.Data;

namespace CodeFirst.Support
{
  internal sealed class CustomInitializerDroppingDatabaseAlwaysWithDataSet 
    : CustomInitializerDroppingDatabaseAlways
  {
    protected override void Seed(CustomerContext context)
    {
      // customers
      context.Customers.Add(new Customer()
      {
        CustomerId = 1,
        CompanyName = "First customer"
      });
      context.Customers.Add(new Customer()
      {
        CustomerId = 2,
        CompanyName = "Second customer"
      });

      // orders
      context.Orders.Add(new Order()
      {
        OrderId = 1,
        CustomerId = 1,
        OrderDate = DateTime.Now
      });
      context.Orders.Add(new Order()
      {
        OrderId = 2,
        CustomerId = 2,
        OrderDate = DateTime.Now
      });

      base.Seed(context);
    }
  }
}
