﻿using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Data.Entity.SqlServer;
using CodeFirst.Data;
using CodeFirst.Migrations;

namespace CodeFirst.Support
{
  public sealed class CustomerConfiguration : DbConfiguration
  {
    public CustomerConfiguration()
    {
      // default connection factory, no config file
      SetDefaultConnectionFactory(new SqlConnectionFactory());

      // set provider service, no config file
      SetProviderServices("System.Data.SqlClient", SqlProviderServices.Instance);

      // adding command interceptor
      //AddInterceptor(new CustomCommandInterceptor());

      // no database created
      //SetDatabaseInitializer<CustomerContext>(null);

      // database created only when not existing
      //SetDatabaseInitializer(new CustomInitializerCreatingDatabaseIfNotExisting());

      // database drop when model is changed
      //SetDatabaseInitializer(new CustomInitializerDroppingDatabaseIfModelChanges());

      // database is droped always
      //SetDatabaseInitializer(new CustomInitializerDroppingDatabaseAlways());

      // database is droped always, data set is imported
      //SetDatabaseInitializer(new CustomInitializerDroppingDatabaseAlwaysWithDataSet());

      // migrations
      SetDatabaseInitializer(new MigrateDatabaseToLatestVersion<CustomerContext, Configuration>("CustomerConnectionString"));
    }
  }
}
