﻿using System.Data.Entity.ModelConfiguration;
using CodeFirst.Data;

namespace CodeFirst.Support
{
  internal sealed class CustomerEntityConfiguration : 
    EntityTypeConfiguration<Customer>
  {
    public CustomerEntityConfiguration()
    {
      // db table name change via mapping
      ToTable("Customers");

      // property persistence ignoration
      Ignore(i => i.Fax);

      // column mapping
     Property(p => p.CustomerId)
                  .HasColumnName("CId")
                  .HasColumnType("int");

      // set column as null
     Property(p => p.Phone)
             .IsOptional();

      // set column as not null
     Property(p => p.PostalCode)
             .IsOptional();

     Property(p => p.PostalCode)
       .HasMaxLength(10).IsFixedLength();
    }
  }
}
