﻿using System;
using System.ComponentModel.DataAnnotations;

namespace DbFirst.Metadata
{
  public sealed class ProductMetadata
  {
    [Required(ErrorMessage = "Product Id required")]
    public int ProductID { get; set; }

    [Display(Name = "Name")]
    [DataType(DataType.Text)]
    [StringLength(64)]
    [Required(ErrorMessage = "Product name required")]
    public string ProductName { get; set; }

    public Nullable<int> SupplierID { get; set; }

    public Nullable<int> CategoryID { get; set; }

    [StringLength(64)]
    public string QuantityPerUnit { get; set; }

    public Nullable<decimal> UnitPrice { get; set; }

    public Nullable<short> UnitsInStock { get; set; }

    public Nullable<short> UnitsOnOrder { get; set; }

    public Nullable<short> ReorderLevel { get; set; }
  }
}
