﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using MvcApplication.Models;
using WpfModel;

namespace MvcApplication.Controllers
{
  [Authorize]
  public class PersonController : Controller
  {
    static PersonController()
    {
      Persons.Add(new Person()
      {
        Name = "Jaroslav",
        Surname = "Nečas",
        Address = "Bednaříkova 2883/1b",
        DateOfBirth = new DateTime(1983, 12, 27)
      });
    }

    private static readonly List<Person> Persons = new List<Person>();

//
    // GET: /Person/

    public ViewResult Index()
    {
      return View(Persons);
    }

    //
    // GET: /Person/Details/5

    public ViewResult Details(String name)
    {
      var person = Persons.FirstOrDefault(i => i.Surname == name);
      return View(person);
    }

    //
    // GET: /Person/Create

    public ViewResult Create()
    {
      return View();
    }

    //
    // POST: /Person/Create

    [HttpPost]
    public ActionResult Create(FormCollection collection)
    {
      try
      {
        // TODO: Add insert logic here

        return RedirectToAction("Index");
      }
      catch
      {
        return View();
      }
    }

    //
    // GET: /Person/Edit/5

    public ActionResult Edit(String name)
    {
      var person = Persons.FirstOrDefault(i => i.Surname == name);
      return View(person);
    }

    //
    // POST: /Person/Edit/5

    [HttpPost]
    public ActionResult Edit(String name, FormCollection collection)
    {
      try
      {
        // TODO: Add update logic here

        return RedirectToAction("Index");
      }
      catch
      {
        return View();
      }
    }

    //
    // GET: /Person/Delete/5

    public ActionResult Delete(String name)
    {
      var person = Persons.FirstOrDefault(i => i.Surname == name);
      return View(person);
    }

    //
    // POST: /Person/Delete/5

    [HttpPost]
    public ActionResult Delete(String name, FormCollection collection)
    {
      try
      {
        // TODO: Add delete logic here

        return RedirectToAction("Index");
      }
      catch
      {
        return View();
      }
    }
  }
}
