﻿using System.Data.Entity;
using System.Linq;
using System.Web.Mvc;
using DbFirst;

namespace MvcApplicationDbFirst.Controllers
{
  //[Authorize]
  //[HandleError]
  public sealed class CustomersController : Controller
  {
    [HttpGet]
    public ActionResult Index()
    {
      using (var db = new NORTHWNDEntities())
      {
        var items = db.Customers.ToList();
        return View(items);
      }
    }

    [HttpGet]
    public ActionResult Orders(string id)
    {
      using (var db = new NORTHWNDEntities())
      {
        var customer = db.Customers
          .Include(cust => cust.Orders)
          .Include(cust => cust.Orders.Select(o => o.Customers))
          .Include(cust => cust.Orders.Select(o => o.Employees))
          .Include(cust => cust.Orders.Select(o => o.Shippers)).FirstOrDefault(i => i.CustomerID == id);

        //var customer = db.Customers
          //.Include("Orders.Employees")
          //.Include("Orders.Shippers")
          //.FirstOrDefault(i => i.CustomerID == id);

        if (customer != null)
        {
          return View("Orders", customer.Orders);
        }

        return View("NotFound");
      }
    }

    [HttpPost]
    public ActionResult ShowDetail(string id)
    {
      using (var db = new NORTHWNDEntities())
      {
        var customer = db.Customers.FirstOrDefault(i => i.CustomerID == id);
        return PartialView("Detail", customer);
      }
    }
  }
}