﻿using System;
using Microsoft.Practices.Prism.Mvvm;   

namespace WpfModel
{
  public sealed class Person : BindableBase
  {
    private bool _isChanged;
    public Boolean IsChanged
    {
      get { return _isChanged; }
      set { SetProperty(ref _isChanged, value); }
    }

    private string _name;
    public string Name
    {
      get
      {
        return _name;
      }
      set
      {
        if (SetProperty(ref _name, value))
        {
          IsChanged = true;
        }
      }
    }

    private string _surname;
    public string Surname
    {
      get
      {
        return _surname;
      }
      set
      {
        if (SetProperty(ref _surname, value))
        {
          IsChanged = true;
        }
      }
    }

    private string _address;
    public string Address
    {
      get
      {
        return _address;
      }
      set
      {
        if (SetProperty(ref _address, value))
        {
          IsChanged = true;
        }
      }
    }

    private DateTime? _dateOfBirth;
    public DateTime? DateOfBirth
    {
      get
      {
        return _dateOfBirth;
      }
      set
      {
        if (SetProperty(ref _dateOfBirth, value))
        {
          IsChanged = true;
        }
      }
    }

    public Person()
    {
      DateOfBirth = null;
    }

    public bool IsValid()
    {
      return !String.IsNullOrEmpty(Name) && !String.IsNullOrEmpty(Surname) 
        && !String.IsNullOrEmpty(Address);
    }
  }
}
