﻿namespace WpfModel.Validation
{
  /// <summary>
  /// Possible view model states.
  /// </summary>
  public enum ObjectState
  {
    /// <summary>
    /// Unknown view model state.
    /// </summary>
    Unknown = 0,

    /// <summary>
    /// View mode is valid state.
    /// </summary>
    Ok = 1,

    /// <summary>
    /// View model, is in the work state.
    /// </summary>
    AtWork = 2,

    /// <summary>
    /// View model is in information state
    /// </summary>
    Info = 3,

    /// <summary>
    /// View model is in warning state.
    /// </summary>
    Warning = 4,

    /// <summary>
    /// View model is in the error state.
    /// </summary>
    Error = 5,
  };
}
